#
# spec file for package openssh (Version 2.9.9p2)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  autoconf automake openssl openssl-devel tcpd xf86
# usedforbuild    aaa_base aaa_dir base bash bindutil bison bzip compress cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext libtool libz openssl openssl-devel pam perl rpm tcpd xdevel xf86 xshared

Name:         openssh
Copyright:    BSD
Group:        Applications/Networking
Provides:     ssh
Requires:     /bin/netstat
Conflicts:    nonfreessh
Autoreqprov:  on
Version:      2.9.9p2
Release:      156
Summary:      Secure shell client and server (remote login program)
Url:          http://www.openssh.com/
Source:       %{name}-%{version}.tar.bz2
Source1:      %{name}-SuSE.tar.bz2
Source2:      sshd.pamd
Source3:      x11-ssh-askpass-1.2.2.tar.bz2
Source4:      README.SuSE
Patch:        %{name}-%{version}.dif
Patch1:       x11-ssh-askpass-1.2.2.dif
Patch2:       %{name}-%{version}.uselogin-security-patch.dif
Patch3:       %{name}-%{version}-channelbug.dif
Patch4:       %{name}-overflow.dif
Patch5:       %{name}-%{version}-readpassphrase.patch
Patch6:       %{name}-%{version}-racecondition-fix.diff
Patch7:       %{name}-%{version}-racecondition-fix2.diff
Patch8:       %{name}-%{version}-solardesigner-realloc.diff
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
Ssh  (Secure  Shell) is a program for logging into a remote
machine and for executing commands on  a  remote  machine.
It  is intended  to  replace  rlogin and rsh, and provides
secure  encrypted  communication  between  two  untrusted
hosts over an insecure network.  X11 connections and
arbiarbitrary TCP/IP ports can also be forwarded over the
secure channel.

Authors:
--------
    Aaron Campbell
    Bob Beck
    Markus Friedl
    Niels Provos
    Theo de Raadt
    Dug Song
    Ben Taylor <bent@clark.net>
    Chip Salzenberg <chip@valinux.com>
    Chris Saia <csaia@wtower.com>
    Dan Brosemer <odin@linuxfreak.com>
    Jim Knoble <jmknoble@pobox.com>
    Marc G. Fournier <marc.fournier@acadiau.ca>
    Nalin Dahyabhai <nalin.dahyabhai@pobox.com>
    Niels Kristian Bech Jensen <nkbj@image.dk>
    Phil Hands <phil@hands.com>
    Thomas Neumann <tom@smart.ruhr.de>
    Tudor Bosman <tudorb@jm.nu>
    Damien Miller <djm@ibs.com.au>

SuSE series: sec

%define prefix   /usr
%prep
%setup -b 3 -a 1
%patch
%patch2
cp -v %{SOURCE4} .
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
cd ../x11-ssh-askpass-*
%patch1

%build
%{?suse_update_config:%{suse_update_config}}
aclocal
autoconf
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
							--mandir=%{_mandir} \
							--prefix=%{prefix} \
							--infodir=%{_infodir} \
							--sysconfdir=/etc/ssh \
							--libexecdir=%{prefix}/lib/ssh \
							--with-tcp-wrappers \
							--with-pam \
							%{_target_cpu}-suse-linux
make
cd ../x11-ssh-askpass-1.2.2
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
							--mandir=%{prefix}/X11R6/man \
							--prefix=%{prefix} \
							--libexecdir=%{prefix}/lib/ssh
xmkmf
make includes
make

%install
rm -rf $RPM_BUILD_ROOT;
make DESTDIR=$RPM_BUILD_ROOT/ install
install -d -m 755 $RPM_BUILD_ROOT/etc/pam.d
install -m 644 %{S:2} $RPM_BUILD_ROOT/etc/pam.d/sshd
cp -a SuSE/* $RPM_BUILD_ROOT
cd ../x11-ssh-askpass-1.2.2
make BINDIR=/usr/lib/ssh DESTDIR=$RPM_BUILD_ROOT install install.man

%post
echo "Updating etc/rc.config..."
if [ -x bin/fillup ] ; then
  bin/fillup -q -d = etc/rc.config var/adm/fillup-templates/rc.config.ssh
else
  echo "ERROR: fillup not found. This should not happen. Please compare"
  echo "etc/rc.config and var/adm/fillup-templates/rc.config.ssh and"
  echo "update by hand."
fi
sbin/insserv etc/init.d/sshd
cat >var/adm/notify/messages/openssh_update << _END_
Dear sysadmin,
Please note that one default feature of openssh has been changed
between SuSE Linux 6.4 (3.4.2000) - openssh version 1.2.2 - and 
SuSE Linux 7.0 (31.7.2000) - openssh version 2.1.1p1: X11-forwarding.
It is disabled by default now for security reasons. You need to 
explicitly enable by the parameter -X, if you want to use it.
You may also enable it by default by changing it globally (or 
selectively for certain hosts) by setting "ForwardX11 yes" in
/etc/ssh/ssh_config.
Users may do it individually by putting this statement in their
~/.ssh/config.
Yours,
	SuSE Security Team
Lieber Systemadministrator,
Bitte beachten Sie, dass sich von SuSE Linux 6.4 (3.4.2000) - openssh 
Version 1.2.2 - auf SuSE Linux 7.0 (31.7.2000) - openssh Version 2.1.1p1
ein Standardfeature gendert hat: X11-forwarding. Es ist nun aus
Sicherheitsgrnden standardmig deaktiviert. Wenn Sie es verwenden wollen,
mssen Sie es explizit mit dem Parameter -X aktivieren. Sie knnen es auch
standardmig aktivieren, indem Sie eine globale nderung vornehmen (oder
selektiv fr einzelne Rechner). Tragen Sie dazuin /etc/ssh/ssh_config 
"ForwardX11 yes" ein.
Benutzer knnen dies auch individuell einstellen, indem sie "ForwardX11 yes"
in ihre ~/.ssh/config eintragen.
Ihr,
	SuSE Security Team
_END_
exit 0

%postun
sbin/insserv etc/init.d

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README.SuSE ChangeLog OVERVIEW README RFC.nroff TODO LICENCE CREDITS
%attr(0644,root,root) %config /etc/pam.d/sshd
%attr(0755,root,root) %dir /etc/ssh
%attr(0600,root,root) %config(noreplace) /etc/ssh/sshd_config
%attr(0644,root,root) %config(noreplace) /etc/ssh/ssh_config
%attr(0600,root,root) %config(noreplace) /etc/ssh/moduli
%attr(0755,root,root) %config /etc/init.d/sshd
/usr/sbin/*
/usr/bin/*
%attr(0755,root,root) %dir /usr/lib/ssh
%attr(0755,root,root) /usr/lib/ssh/ssh-askpass
%attr(0755,root,root) /usr/lib/ssh/x11-ssh-askpass
%attr(0755,root,root) /usr/lib/ssh/sftp-server
%doc /usr/share/man/*/*
%doc /usr/X11R6/man/man1/*
/var/adm/fillup-templates/rc.config.ssh
%config /usr/X11R6/lib/X11/app-defaults/SshAskpass

%changelog -n openssh
* Thu Sep 18 2003 - draht@suse.de
- again [#31025], this time CAN-2003-0695, buffer.c and channels.c
  security bugfixes as fixed in upstream 3.7.1
  (openssh-*-racecondition-fix2.diff).
  openssh-*-solardesigner-realloc.diff adds fixes by Solar
  Designer, identified by CAN-2003-0682
* Tue Sep 16 2003 - postadal@suse.cz
- fixed race condition in allocating memory [#31025] (CAN-2003-0693)
* Fri Oct 25 2002 - postadal@suse.cz
- fixed security problem: when password expired the forced password change
  echoed the password on the screen [bug #20903].
* Fri Jun 28 2002 - okir@suse.de
- fixed broken %%patch statement; re-added channelbug diff
* Fri Jun 28 2002 - okir@suse.de
- back down to 2.9.9, with patch
* Tue Jun 25 2002 - okir@suse.de
- patch for privilege separation+PAM
* Tue Jun 25 2002 - ro@suse.de
- add UsePrivilegeSeparation no to sshd_config if option not
  found in postinstall
* Mon Jun 24 2002 - okir@suse.de
- Updated to 3.3p1 (security update)
* Wed Mar 06 2002 - draht@suse.de
- Added openssh-2.9.9p2-channelbug.dif for bug in channel.c
* Wed Dec 05 2001 - draht@suse.de
- Added openssh-2.9.9p2.uselogin-security-patch.dif against the
  UseLogin vulnerability.
* Tue Nov 06 2001 - cihlar@suse.cz
- update to version 2.9.9p2:
  * fixed security problem with IP based access
  control restriction
- removed obsolete clientloop and command patches
- uncommented "HostKey /etc/ssh/ssh_host_rsa_key" in sshd_config
- added German translation of e-mail to sysadmin
- added /bin/netstat to requires
* Mon Sep 24 2001 - cihlar@suse.cz
- fixed security problem with sftp & bypassing
  keypair auth restrictions - patch based on CVS
- fixed status part of init script - it returned
  running even if there were only sshd of connections
  and no listening sshd [#11220]
- fixed stop part of init script - when there was no
  /var/run/sshd.pid, all sshd were killed
* Thu Sep 06 2001 - nadvornik@suse.cz
- added patch for correct buffer flushing from CVS [bug #6450]
* Fri Jul 27 2001 - cihlar@suse.cz
- update x11-ssh-askpass to version 1.2.2
* Thu Jul 26 2001 - cihlar@suse.cz
- update to version 2.9p2
- removed obsolete "cookies" patch
* Mon Jun 11 2001 - cihlar@suse.cz
- fixed to compile with new xmkmf
* Thu Jun 07 2001 - cihlar@suse.cz
- fixed security bug when any file "cookies" could
  be removed by anybody
* Tue Jun 05 2001 - bjacke@suse.de
- generate rsa host key in init script
* Tue Jun 05 2001 - cihlar@suse.cz
- removed complete path from PAM modules
* Thu May 03 2001 - cihlar@suse.cz
- update to version 2.9p1
- removed obsolete --with-openssl
- removed obsolete man patch
* Mon Apr 30 2001 - cihlar@suse.cz
- enable PAM support
* Fri Apr 13 2001 - ro@suse.de
- fixed specfile for extra README.SuSE
* Fri Apr 13 2001 - cihlar@suse.cz
- fixed init script by new skeleton
* Thu Mar 22 2001 - cihlar@suse.cz
- update to version 2.5.2p2
* Wed Mar 14 2001 - cihlar@suse.cz
- fixed ssh man page
* Mon Mar 12 2001 - cihlar@suse.cz
- update to version 2.5.1p2
- added xf86 to neededforbuild
* Fri Mar 09 2001 - schwab@suse.de
- Fix missing crypt declaration.
* Fri Feb 23 2001 - cihlar@suse.cz
- update to version 2.5.1p1
- update x11-ssh-askpass to version 1.2.0
* Tue Feb 20 2001 - cihlar@suse.cz
- modified README.SuSE [#4365]
- fixed start script to agree with skeleton
- fixed start script so "stop" kills only sshd
  listening for connections
- compiled with --with-openssl
- "ListenAddress 0.0.0.0" in sshd_config commented out -
  listen on both ipv4 and ipv6
- fixed var/adm/notify/messages/openssh_update [#6406]
* Thu Jan 25 2001 - smid@suse.cz
- startup script fixed [#5559]
* Tue Jan 16 2001 - nadvornik@suse.cz
- libcrypto linked static [#5333]
* Thu Jan 11 2001 - cihlar@suse.cz
- uncomment sftp-server part in sshd_config
- added /usr/X11R6/lib/X11/app-defaults/SshAskpass to %%files
* Thu Jan 11 2001 - cihlar@suse.cz
- fixed %%files [#5230]
- fixed installation of x11-ssh-askpass to BuildRoot
- added man pages of x11-ssh-askpass
* Wed Jan 10 2001 - smid@suse.cz
- notice about how to enable ipv6 added to mail
- for administrator [#5297]
* Wed Dec 13 2000 - smid@suse.cz
- default ipv6 listennig disabled (problems with libc2.2) [#4588]
* Tue Dec 05 2000 - smid@suse.cz
- notify message changed
* Mon Dec 04 2000 - lmuelle@suse.de
- fixed provides/ conflicts to ssh
* Thu Nov 30 2000 - smid@suse.cz
- path to ssh-askpass fixed
- stop in %%preun removed
- new init style
* Sun Nov 26 2000 - schwab@suse.de
- Restore rcsshd link.
* Sun Nov 26 2000 - kukuk@suse.de
- Add openssl-devel to neededforbuild
* Mon Nov 20 2000 - smid@suse.cz
- New version 2.3.0
* Wed Sep 06 2000 - smid@suse.cz
- remove --with-ipv4-default option
* Wed Jul 05 2000 - garloff@suse.de
- ... and tell the sysadmin and user more about what they can do
  about it (schwab).
* Wed Jul 05 2000 - garloff@suse.de
- Inform the user (admin) about the fact that the default behaviour
  with respect to X11-forwarding has been changed to be disabled.
* Wed Jun 28 2000 - smid@suse.cz
- warning that generating DSA key can an take a long time.
  (bugzilla 3015)
- writing to wtmp and lastlog fixed (bugzilla 3024)
- reading config file (parameter Protocol) fixed
* Fri Jun 16 2000 - garloff@suse.de
- Added generation of ssh_host_dsa_key
* Tue Jun 13 2000 - nadvornik@suse.cz
- update to 2.1.1p1
* Thu Jun 08 2000 - cihlar@suse.cz
- uncommented %%clean
* Fri May 05 2000 - smid@suse.cz
- buildroot added
- upgrade to 1.2.3
* Tue Mar 21 2000 - kukuk@suse.de
- Update to 1.2.2p1
* Mon Mar 06 2000 - kukuk@suse.de
- Fix the diff.
* Sun Mar 05 2000 - kukuk@suse.de
- Add a README.SuSE with a short description how to use ssh-add
* Tue Feb 29 2000 - schwab@suse.de
- Update config.{guess,sub}.
* Fri Feb 25 2000 - kukuk@suse.de
- Fix need for build, add group tag.
* Wed Feb 02 2000 - kukuk@suse.de
- Change new defaults back to old one
* Sun Jan 30 2000 - kukuk@suse.de
- Add x11-ssh-askpass to filelist
* Fri Jan 28 2000 - kukuk@suse.de
- Update to OpenSSH 1.2.2
- Add x11-ssh-askpass-1.0
* Tue Jan 25 2000 - kukuk@suse.de
- Add reload and status to /sbin/init.d/sshd [Bug 1747]
* Thu Jan 20 2000 - kukuk@suse.de
- Update to 1.2.1pre27 with IPv6 support
* Fri Dec 31 1999 - kukuk@suse.de
- Initial version
